/*
 *  - dos/prot_dos.c
 *
 *  - dos specific protocol main loop
 *
 *  This file is part of the VC 1541 Emulator.
 *  Copyright (c) 1997 Torsten Paul
 */

#include <dos.h>
#include <stdio.h>

#include "common.h"
#include "vc1541.h"

extern long ss_timeout;
extern int dump_screen;
extern word_t videoseg;

void mainloop_dos(void) {
	FILE *f;
	char far *ptr;
	int a;
	int ready = 1;
	long saver = ss_timeout;

	while (1) {
		if (Get(ATN)) {
			cli();
			Set(CLOCK, 0); 			       /* [$e86d] */
			Set(DATA, DATA);		       /* [$e870] */
			if (inportb(0x60) == 1) break;   /* check ESC key */
			if (saver == 1) ScreenSaver(0);
			handle_ATN();
			ready = 10000;
			saver = ss_timeout;
			continue;
		}
		Set(DATA | CLOCK, 0);
		sti();
		MicroSleep(100);
		if (inportb(0x60) == 1) break;		 /* check ESC key */
		if (ready == 1) ErrorInfo("ready.");
		if (ready > 0) ready--;
		if (saver == 1) {
			ScreenSaver(1);
		} else {
			Idle();
			saver--;
		}
	}
	sti();
	Set(DATA | CLOCK, 0);
	ScreenSaver(0);

	if (dump_screen) {
		if ((f = fopen("screen.txt", "wb")) != NULL) {
			ptr = MK_FP(videoseg, 0);
			for (a = 0;a < 4000;a++) fputc(*ptr++, f);
		}
	}
}
